



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MySQL(Innodb)索引的原理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MySQL(Innodb)索引的原理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-14 05:45:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>引言</h2>
<p>回想四年前，我在学习mysql的索引这块的时候，老师在讲索引的时候，是像下面这么说的</p>
<blockquote><p><strong>索引就像一本书的目录。而当用户通过索引查找数据时，就好比用户通过目录查询某章节的某个知识点。这样就帮助用户有效地提高了查找速度。所以，使用索引可以有效地提高数据库系统的整体性能。</strong></p></blockquote>
<p>嗯，这么说其实也对。但是呢，大家看完这种说法，其实可能还是觉得太抽象了！因此呢，我还想再深入的细说一下，所以就有了此文！<br />需要说明的是，我说的内容只在Mysql的Innodb引擎中是成立的。在Sql Server、oracle、Mysql的Mysiam引擎中的正确性，不一定成立！<br />OK，废话不多说，开始啰嗦!</p>
<h2>正文</h2>
<h3>索引的科普</h3>
<p>先引进聚簇索引和非聚簇索引的概念！<br />我们平时在使用的Mysql中，使用下述语句</p>
<pre class="prettyprint linenums"><code>CREATE [UNIQUE|FULLTEXT|SPATIAL] INDEX index_name<br />
    [USING index_type]<br />
    ON tbl_name (index_col_name,...)

index_col_name:<br />
    col_name [(length)] [ASC | DESC]</code></pre>
<p>创建的索引，如复合索引、前缀索引、唯一索引，都是属于非聚簇索引，在有的书籍中，又将其称为辅助索引(secondary index)。在后文中，我们称其为非聚簇索引，其数据结构为B+树。</p>
<p>那么，这个聚簇索引，在Mysql中是没有语句来另外生成的。在Innodb中，Mysql中的数据是按照主键的顺序来存放的。那么聚簇索引就是按照每张表的主键来构造一颗B+树，叶子节点存放的就是整张表的行数据。由于表里的数据只能按照一颗B+树排序，因此一张表只能有一个聚簇索引。</p>
<p>在Innodb中，聚簇索引默认就是主键索引。<br />这个时候，机智的读者，应该要问我</p>
<blockquote><p><strong>如果我的表没建主键呢？</strong></p></blockquote>
<p>回答是，如果没有主键，则按照下列规则来建聚簇索引</p>
<ul><li>没有主键时，会用一个唯一且不为空的索引列做为主键，成为此表的聚簇索引</li>
<li>如果没有这样的索引，InnoDB会隐式定义一个主键来作为聚簇索引。</li></ul>
<p><code>ps</code>:大家还记得，自增主键和uuid作为主键的区别么？由于主键使用了聚簇索引，如果主键是自增id，，那么对应的数据一定也是相邻地存放在磁盘上的，写入性能比较高。如果是uuid的形式，频繁的插入会使innodb频繁地移动磁盘块，写入性能就比较低了。</p>
<h3>索引原理介绍</h3>
<p>先来一张带主键的表，如下所示，pId是主键</p>
<table>
<thead>
<tr>
<th>pId</th>
<th>name</th>
<th>birthday</th>
</tr>
</thead>
<tbody>
<tr>
<td>5</td>
<td>zhangsan</td>
<td>2016-10-02</td>
</tr>
<tr>
<td>8</td>
<td>lisi</td>
<td>2015-10-04</td>
</tr>
<tr>
<td>11</td>
<td>wangwu</td>
<td>2016-09-02</td>
</tr>
<tr>
<td>13</td>
<td>zhaoliu</td>
<td>2015-10-07</td>
</tr>
</tbody>
</table>
<p>画出该表的结构图如下<br /><img referrerpolicy="no-referrer"src="https://www.cnblogs.com/images/cnblogs_com/rjzheng/1281019/o_index01.png" /></p>
<p>如上图所示，分为上下两个部分，上半部分是由主键形成的B+树，下半部分就是磁盘上真实的数据！那么，当我们， 执行下面的语句</p>
<pre class="prettyprint linenums"><code>select * from table where pId='11'</code></pre>
<p>那么，执行过程如下<br /><img referrerpolicy="no-referrer"src="https://www.cnblogs.com/images/cnblogs_com/rjzheng/1281019/o_index02.png" /><br />如上图所示，从根开始，经过3次查找，就可以找到真实数据。如果不使用索引，那就要在磁盘上，进行逐行扫描，直到找到数据位置。显然，使用索引速度会快。但是在写入数据的时候，需要维护这颗B+树的结构，因此写入性能会下降！<br />OK，接下来引入非聚簇索引!我们执行下面的语句</p>
<pre class="prettyprint linenums"><code>create index index_name on table(name);</code></pre>
<p>此时结构图如下所示<br /><img referrerpolicy="no-referrer"src="https://www.cnblogs.com/images/cnblogs_com/rjzheng/1281019/o_index04.png" /><br />大家注意看，会根据你的索引字段生成一颗新的B+树。因此， 我们每加一个索引，就会增加表的体积， 占用磁盘存储空间。然而，<strong>注意看叶子节点</strong>，非聚簇索引的叶子节点并不是真实数据，它的叶子节点依然是索引节点，存放的是该索引字段的值以及对应的主键索引(聚簇索引)。<br />如果我们执行下列语句</p>
<pre class="prettyprint linenums"><code>select * from table where name='lisi'</code></pre>
<p>此时结构图如下所示<br /><img referrerpolicy="no-referrer"src="https://www.cnblogs.com/images/cnblogs_com/rjzheng/1281019/o_index05.png" /><br />通过上图红线可以看出，先从非聚簇索引树开始查找，然后找到聚簇索引后。根据聚簇索引，在聚簇索引的B+树上，找到完整的数据！<br />那</p>
<blockquote><p><strong>什么情况不去聚簇索引树上查询呢？</strong></p></blockquote>
<p>还记得我们的非聚簇索引树上存着该索引字段的值么。如果，此时我们执行下面的语句</p>
<pre class="prettyprint linenums"><code>select name from table where name='lisi'</code></pre>
<p>此时结构图如下<br /><img referrerpolicy="no-referrer"src="https://www.cnblogs.com/images/cnblogs_com/rjzheng/1281019/o_index06.png" /><br />如上图红线所示，如果在非聚簇索引树上找到了想要的值，就不会去聚簇索引树上查询。还记得，博主在<a href="https://www.cnblogs.com/rjzheng/p/9902911.html" rel="external nofollow noreferrer">《select的正确姿势》</a>提到的索引问题么：</p>
<blockquote><p><strong>当执行select col from table where col = ?，col上有索引的时候，效率比执行select * from table where col = ? 速度快好几倍！</strong></p></blockquote>
<p>看完上面的图，你应该对这句话有更深层的理解了。</p>
<p>那么这个时候，我们执行了下述语句，又会发生什么呢？</p>
<pre class="prettyprint linenums"><code>create index index_birthday on table(birthday);</code></pre>
<p>此时结构图如下<br /><img referrerpolicy="no-referrer"src="https://www.cnblogs.com/images/cnblogs_com/rjzheng/1281019/o_index07.png" /><br />看到了么，多加一个索引，就会多生成一颗非聚簇索引树。因此，很多文章才说，索引不能乱加。因为，有几个索引，就有几颗非聚簇索引树！你在做插入操作的时候，需要同时维护这几颗树的变化！因此，如果索引太多，插入性能就会下降!</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kp4e59.html">Java集合框架练习-计算表达式的值</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8knxp68.html">HTML5：web socket 和 web worker</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdg26zq.html">Spring-Context之六&colon;基于Setter方法进行依赖注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyjmoxq.html">Unity3D外包团队&mdash;&mdash;技术分享U3D全景漫游（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j367gq.html">【笔记】《DirectX 9&period;0 3D游戏开发编程基础》：Direct3D初始化</a>
		</li>
						<li><a href="https://www.batexi.com/a/r930ekz9.html">iOS 瀑布流的基本原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zlp349.html">vim插件介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnv4208.html">ValidateBox&lpar; 验证框&rpar; 组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1761j8.html">Jquery 工具类函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjz1ok9.html">&lbrack;转&rsqb;struct 用法深入探索</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdnj179.html">iOS开展-CocoaPods安装和使用教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljezee9.html">KMP算法原理与实现（精简）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zork5vq.html">SQLite Lemon 语法分析器学习与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zgen19.html">spring cloud 集成 swagger2 构建Restful APIS 说明文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdgw049.html">Javascript之学习笔记每日更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pzk5n8.html">Python中的切片符</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zow771q.html">yii2在控制器中调用另一个控制器方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zep5j9.html">timesten 修改最大连接数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyydn4jq.html">sql语句实例练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5gm5dq.html">Cocos2dx开发之运行与渲染流程分析</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnvpd5k8.html">git log乱码显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m21d60q.html">Android adb logcat输出日志显示不全解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wmj5rq.html">Hadoop 管理工具HUE配置-filebrowser配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv3woy8.html">pos省纸的妙招</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwl7778.html">Java内存泄漏相关</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy0l7v9.html">Spark2&period;0&period;0源码编译</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m21z56q.html">Hive性能调优</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jl2knq.html">TextView右上角显示小红点，小红点根据TextView的长度移动，小红点被TextView挤出去不显示的问题；</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwlygd8.html">Android 打开高德地图、百度地图进行导航；打开第三方App去导航；</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4z65z9.html">web分页打印</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
